#include <cstdio>
#include "pthread.h"
#include "HttpDownload.h"
#include "InitWinSocket.h"

InitWinSocket init;
const char* g_progName = NULL;
const char* g_saveFileName = "savefilename";

void usage() {
	printf("Usage: %s http://www.xxx.com/filename %s\n", g_progName, g_saveFileName);
}

void progressBar(float percent) {
	const int numTotal = 50;
	int numShow = (int)(numTotal * percent);
	if (numShow == 0)
		numShow = 1;
	if (numShow > numTotal)
		numShow = numTotal;
	char sign[numTotal+1] = {0};
	memset(sign, '=', numTotal);
	printf("\r%.2f%%\t[%-*.*s]", percent*100, numTotal, numShow, sign);
	fflush(stdout);
	if (numShow == numTotal)
		printf("\n");
}

void parseURL(const char* url, char* hostAddr, int& port, char* getPath) {
	if (url == NULL || hostAddr == NULL || getPath == NULL)
		return;
	const char* temp = strstr(url, "http://");
	if (temp == NULL)
		return;
	const char* hostStart = temp + strlen("http://");
	const char* colon = strchr(hostStart, ':');
	if (colon != NULL)	//ʾð,ж˿ں
		sscanf(hostStart, "%[^:]:%d%s", hostAddr, &port, getPath);
	else
		sscanf(hostStart, "%[^/]%s", hostAddr, getPath);
	//ͨתIPַ
	struct hostent* hostEntry;
	hostEntry = gethostbyname(hostAddr);	
	if (hostEntry == NULL)
	{
		printf("Hostname not available!\n");
		return;
	}
	struct in_addr inAddr = {0};
	memcpy(&inAddr.s_addr, hostEntry->h_addr, sizeof(inAddr.s_addr));
	strcpy(hostAddr, inet_ntoa(inAddr));
}

void* task(void* arg) {
	HttpDownload* pObj = (HttpDownload*)arg;
	if (pObj->start())
		return ((void*)1);
	else
		return ((void*)0);
}

int main(int argc, char** argv) {
	g_progName = strrchr(argv[0], '\\');
	if (g_progName != NULL)
		g_progName += 1;
	else
		g_progName = argv[0];
	if (argc != 3 || strncmp(argv[1], "http://", strlen("http://")) != 0) {
		usage();
		return -1;
	}
	g_saveFileName = argv[2];
	
	char hostAddr[256] = {0};
	int port = 80;
	char getPath[256] = {0};
	parseURL(argv[1], hostAddr, port, getPath);
	
	HttpDownload obj(hostAddr, port, getPath, g_saveFileName);	//
	pthread_t tid;
	int err = pthread_create(&tid, NULL, task, &obj);
	if (err != 0)
		printf("Start Download Failed!\n");
	else
		printf("Start Downloading...\n");
	
	ULONGLONG totalSize = 1;
	ULONGLONG downloadSize = 0;
	float percent = 0;
	while (1) {
		obj.getPos(totalSize, downloadSize);
		percent = downloadSize/(float)totalSize;
		progressBar(percent);
		if (downloadSize == totalSize)
			break;
		Sleep(500);
	}
	
	void* ret = NULL;
	pthread_join(tid, &ret);
	if (ret)
		printf("Download Finished.\n");
	else
		printf("Download Failed!\n");
	return 0;
}
